/***************************************************************************
                          kdlgmanager1.h  -  description
                             -------------------
    begin                : Wed Sep 6 2000
    copyright            : (C) 2000 by Sergio Moretti
    email                : sermore@libero.it
    revision             : $Revision: 1.8 $
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KDLGMANAGER1_H
#define KDLGMANAGER1_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <kurlrequester.h>
#include <kcombobox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <klocale.h>
#include <qwidget.h>
#include <qvaluelist.h>
#include "ktmanager.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

/**
 * @short First Page of @ref KTManager configuration dialog
 * @author Sergio Moretti
 */

class KDlgManager1 : public QWidget  {
  Q_OBJECT
public:
  KDlgManager1(KTManager m, QWidget *parent, const char *name=0);
  ~KDlgManager1();
  /** check if dialog is in an acceptable state */
  bool isAcceptable();
  
protected:
  void initDialog();
  /** init the widgets state */
  void init();

  QCheckBox *cbtAutoDownload;
  QCheckBox *cbtRemoveCompleted;
  KComboBox *cmbType;
  QLineEdit *lnePriority;
  QLineEdit *lneMaxConn;
  QLineEdit *lneMaxBand;
#ifndef KURLREQ_ERR
  KURLRequester *cmbDDir;
  KURLRequester *cmbWDir;
  KURLRequester *cmbLog;
#else
  QLineEdit *lneDDir;
  QPushButton *btnDDir;
  QLineEdit *lneWDir;
  QPushButton *btnWDir;
  QLineEdit *lneLog;
  QPushButton *btnLog;
#endif

public slots: // Public slots
  /** close the dialog accepting the data */
  void accept();

protected slots:
#ifndef KURLREQ_ERR
  void slotOpenDDir() {}
  void slotOpenWDir() {}
  void slotOpenLogFile() {}
#else
  void slotOpenDDir();
  void slotOpenWDir();
  void slotOpenLogFile();
#endif

private:
  KTManager mngr;
  QValueList<int> _typeList;
};

#endif

/* Local Variables: */
/* mode: c++ */
/* End: */
